routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

use App\Models\User;
use Illuminate\Support\Facades\Input;

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

//Admin routes

Route::middleware(['admin'])->group(function () {
    Route::resource('/user', 'Admin\UserController');
    Route::resource('/team', 'Admin\TeamController');
    Route::get('/request', 'Admin\RequestController@index')->name('request.index');
    Route::put('/request', 'Admin\RequestController@update')->name('request.update');
});

//Employee routes

Route::middleware(['employee'])->group(function () {
    Route::get('/myinfo', 'Employee\MyInfoController@index')->name('myinfo.index');
    Route::get('/myinfo/edit', 'Employee\MyInfoController@edit')->name('myinfo.edit');
    Route::put('/myinfo/update', 'Employee\MyInfoController@update')->name('myinfo.update');

    Route::get('/dashboard', 'Employee\DashboardController@index')->name('dashboard.index');
    Route::get('/dashboard/create', 'Employee\DashboardController@create')->name('dashboard.create');
    Route::post('/dashboard', 'Employee\DashboardController@store')->name('dashboard.store');
});

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    const ROLE_ADMIN = 1;
    const ROLE_EMPLOYEE = 0;
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'firstName', 'lastName', 'email', 'password', 'gender', 'earnedDaysOff',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * Get the DeysOff Requests for the user.
     */
    public function requests()
    {
        return $this->hasMany('App\Models\Request');
    }

    /**
     * The teams that belong to the user.
     */
    public function teams()
    {
        return $this->belongsToMany('App\Models\Team');
    }
}

app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Exceptions\EntryNotFoundException;
use App\Http\Controllers\Controller;
use App\Http\Requests\UserRequest;
use App\Models\User;
use App\Repositories\TeamRepository;
use App\Repositories\UserRepository;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Input;

class UserController extends Controller
{
    /**
     * @var UserRepository
     * @var teamRepository
     */
    private $userRepository;
    private $teamRepository;
    public function __construct(UserRepository $userRepository, TeamRepository $teamRepository) {
        $this->userRepository = $userRepository;
        $this->teamRepository = $teamRepository;
    }

    /**
     * Display a listing of the resource.
     *
     */
    //PAGINATED -- include render in template
    public function index(Request $request)
    {
        $search = $request->search;
        $teamsChecked = $request->teams;
        $fromPicked = $request->fromPicked;
        $toPicked = $request->toPicked;
        if (!empty($fromPicked)) {
            $fromPicked = Carbon::parse($fromPicked)->format('Y-m-d');
        }
        if (!empty($toPicked)) {
            $toPicked = Carbon::parse($toPicked)->format('Y-m-d');
        }
        $users = $this->userRepository->paginate(10, $search, $teamsChecked, $fromPicked, $toPicked);
        $teams = $this->teamRepository->all();
        if (empty($teamsChecked)) {
            $teamsChecked = [];
        }
        $request =  $users->appends(Input::except('page'));
        return view('users.index', compact('users','teams', 'search', 'teamsChecked', 'fromPicked', 'toPicked', 'page'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Request $request, $teamPreChecked = null)
    {
            $teamsChecked = $request->teams;
            $teamPreChecked = $request->teamPreChecked;
            $teams = $this->teamRepository->all();
            if (empty($teamsChecked)) {
                $teamsChecked = [];
            }
            return view('users.create', compact('teams', 'teamsChecked', 'teamPreChecked' ));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(UserRequest $request)
    {
        $data = $request->only(['firstName', 'lastName', 'password', 'email', 'gender', 'earnedDaysOff']);
        $data['password'] = Hash::make($request->password);
        $this->userRepository->create($data, $request->teams);
        if (!empty($request->teamPreChecked))
        {
            return redirect()->route('team.show', $request->teamPreChecked);
        }
        return redirect()->route('user.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        try {
            $user = $this->userRepository->getById($id, true);
        } catch (EntryNotFoundException $e) {
            abort(404);
        }
        if ($user->role === User::ROLE_ADMIN)
        {
            $user->role = "admin";
        } else
        {
            $user->role = "user";
        }
        return view('users.show', compact('user'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id, Request $request)
    {
        $teams = $this->teamRepository->all();
        try {
            $user = $this->userRepository->getById($id);
        } catch (EntryNotFoundException $e) {
            abort(404);
        }
        return view('users.edit', compact('user', 'teams'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(UserRequest $request, $id)
    {
       //Retrieving A Portion Of The Input Data
        $data = $request->only(['firstName', 'lastName','email', 'gender','earnedDaysOff']);
        if (!empty($request->password)) {
            $data['password'] = Hash::make($request->password);
        }
        try {
            $this->userRepository->update($data, $id, $request->teams);
        } catch (EntryNotFoundException $e) {
            abort(404);
        }
        return redirect()->route('user.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        try {
            $this->userRepository->delete($id);
        } catch (EntryNotFoundException $e) {
            abort(404);
        }
        return redirect()->route('user.index');
    }
}

resources/views/users/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">{{ __('Create new User') }}</div>
                    <div class="card-body">
                        <form method="POST" action="{{ route('user.store', ["teamPreChecked" => $teamPreChecked]) }}" aria-label="{{ __('Create new User') }}">
                            @csrf
                            <div class="form-group row">
                                <label for="firstName" class="col-md-4 col-form-label text-md-right"></label>
                                <div class="col-md-6">
                                    <input id="firstName" type="text" class="form-control{{ $errors->has('firstName') ? ' is-invalid' : '' }}" name="firstName" value="{{ old('firstName') }}" required autofocus placeholder="First Name">
                                    @if ($errors->has('firstName'))
                                        <span class="invalid-feedback" role="alert">
                                        <strong>{{ $errors->first('firstName') }}</strong>
                                    </span>
                                    @endif
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="lastName" class="col-md-4 col-form-label text-md-right"></label>
                                <div class="col-md-6">
                                    <input id="lastName" type="text" class="form-control{{ $errors->has('lastName') ? ' is-invalid' : '' }}" name="lastName" value="{{ old('lastName') }}" required placeholder="Last Name">

                                    @if ($errors->has('lastName'))
                                        <span class="invalid-feedback" role="alert">
                                        <strong>{{ $errors->first('lastName') }}</strong>
                                    </span>
                                    @endif
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="email" class="col-md-4 col-form-label text-md-right"></label>
                                <div class="col-md-6">
                                    <input id="email" type="email" class="form-control{{ $errors->has('email') ? ' is-invalid' : '' }}" name="email" value="{{ old('email') }}" required placeholder="Email">
                                    @if ($errors->has('email'))
                                        <span class="invalid-feedback" role="alert">
                                        <strong>{{ $errors->first('email') }}</strong>
                                    </span>
                                    @endif
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="password" class="col-md-4 col-form-label text-md-right"></label>
                                <div class="col-md-6">
                                    <input id="password" type="password" class="form-control{{ $errors->has('password') ? ' is-invalid' : '' }}" name="password"  placeholder="Password">
                                    @if ($errors->has('password'))
                                        <span class="invalid-feedback" role="alert">
                                        <strong>{{ $errors->first('password') }}</strong>
                                    </span>
                                    @endif
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="password-confirm" class="col-md-4 col-form-label text-md-right"></label>
                                <div class="col-md-6">
                                    <input id="password-confirm" type="password" class="form-control" name="password_confirmation"  placeholder="Confirm Password">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-md-4 col-form-label text-md-right"></label>
                                <div class="col-md-6">
                                    <div class="btn-group btn-group-toggle" data-toggle="buttons"  title="Select Your Gender">
                                        <label for="gender" class="btn btn-secondary">
                                            <input type="radio" name="gender" id="option1" autocomplete="off" value="male" class="form-control{{ $errors->has('gender') ? ' is-invalid' : '' }}" required> Male
                                        </label>
                                        <label for="gender" class="btn btn-secondary">
                                            <input type="radio" name="gender" id="option2" autocomplete="off" value="female" class="form-control{{ $errors->has('gender') ? ' is-invalid' : '' }}" required> Female
                                        </label>
                                    </div>
                                    @if ($errors->has('gender'))
                                        <span class="invalid-feedback" role="alert">
                                        <strong>{{ $errors->first('gender') }}</strong>
                                    </span>
                                    @endif
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="teams" class="col-md-4 col-form-label text-md-right"></label>
                                <div class="col-md-6">
                                <h6>Select Team Membership</h6>
                                @foreach($teams as $team)
                                    <input type="checkbox" name="teams[]" value="{{ $team->id }}" @if ( (in_array($team->id, old('teams', $teamsChecked))) || (($team->id) == $teamPreChecked)) checked="checked" @endif>
                                        &nbsp{{ $team->teamName }} &nbsp &nbsp &nbsp
                                @endforeach
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="init-days-off" class="col-md-4 col-form-label text-md-right"></label>
                                <div class="col-md-6">
                                    <input id="init-days-off" type="number" class="form-control" name="earnedDaysOff" min="0" max="20"
                                           value="{{ old('earnedDaysOff') }}" required placeholder="Initial Number of Days-Off">
                                </div>
                            </div>
                            <div class="form-group row mb-0">
                                <div class="col-md-6 offset-md-4">
                                    <button type="submit" class="btn btn-primary">
                                        {{ __('Save') }}
                                    </button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/users/edit.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">{{ __('Change User data:') }}</div>
                    <div class="card-body">
                        <form   action="{{ route('user.update', ['id' => $user->id]) }}" method="post" autocomplete="on">
                            <div class="form-group row">
                            <label for="firstName" class="col-xs-12 col-sm-2 col-form-label">First Name:</label>
                            <div class="col-xs-12 col-sm-4">
                                <input type="text" name="firstName" id="firstName" value="{{ old('firstName', $user->firstName) }}" class="form-control is-valid">
                                @if($errors->has('firstName'))
                                    <label for="firstName" class="text-danger">{{ $errors->first('firstName') }}</label>
                                @endif
                            </div>
                            </div>
                            <div class="form-group row">
                            <label for="lastName" class="col-xs-12 col-sm-2 col-form-label">Last Name:</label>
                            <div class="col-xs-12 col-sm-4">
                                <input type="text" name="lastName" id="lastName" value="{{ old('lastName', $user->lastName) }}" class="form-control is-valid">
                                @if($errors->has('lastName'))
                                    <label for="lastName" class="text-danger">{{ $errors->first('lastName') }}</label>
                                @endif
                            </div>
                            </div>
                            <div class="form-group row">
                            <label for="email" class="col-xs-12 col-sm-2 col-form-label">Email:</label>
                            <div class="col-xs-12 col-sm-4">
                                <input type="text" name="email" id="email" value="{{ old('email', $user->email) }}" class="form-control is-valid">
                                @if($errors->has('email'))
                                    <label for="email" class="text-danger">{{ $errors->first('email') }}</label>
                                @endif
                            </div>
                            </div>
                            <div class="form-group row">
                            <label for="password" class="col-xs-12 col-sm-2 col-form-label">Password:</label>
                            <div class="col-xs-12 col-sm-4">
                                <input type="password" name="password" id="password" class="form-control is-valid">
                                @if($errors->has('password'))
                                    <label for="password" class="text-danger">{{ $errors->first('password') }}</label>
                                @endif
                            </div>
                            </div>
                            <div class="form-group row">
                                {{--<label for="password-confirm" class="col-md-4 col-form-label text-md-right"></label>--}}
                                <label for="password-confirm" class="col-xs-12 col-sm-2 col-form-label" text-md-right">{{ __('Confirm Password') }}</label>

                                <div class="col-md-6">
                                    <input id="password-confirm" type="password" class="form-control" name="password_confirmation" placeholder="Confirm Password">
                                </div>
                            </div>

                            <div class="form-group row">
                                {{--<label class="col-md-4 col-form-label text-md-right"></label>--}}
                                <label class="col-xs-12 col-sm-2 col-form-label">{{ __('Gender') }}</label>
                                <div class="col-md-6">
                                    <div class="btn-group btn-group-toggle" data-toggle="buttons"  title="Select Your Gender">
                                        <label for="gender" class="btn btn-secondary @if($user->gender == 'male') active @endif">
                                            <input type="radio" name="gender" id="option1" autocomplete="off" value="male" @if($user->gender ==  'male') checked="checked" @endif /> Male
                                        </label>
                                        <label for="gender" class="btn btn-secondary @if($user->gender == 'female') active @endif">
                                            <input type="radio" name="gender" id="option2" autocomplete="off" value="female" @if($user->gender ==  'female') checked="checked" @endif /> Female
                                        </label>
                                    </div>

                                    @if ($errors->has('gender'))
                                        <span class="invalid-feedback" role="alert">
                                                                <strong>{{ $errors->first('gender') }}</strong>
                                                            </span>
                                    @endif
                                </div>
                            </div>
                            <div class="form-group row">
                                {{--<label for="teams" class="col-md-4 col-form-label text-md-right"></label>--}}
                                <label for="teams" class="col-xs-12 col-sm-2 col-form-label">Teams:</label>
                                <div class="col-md-6">
                                    <h6>Select Team Membership</h6>
                                    @foreach($teams as $team)
                                        <input type="checkbox" name="teams[]" value="{{ $team->id }}" @if (in_array($team->id, old('teams', $user->teams->pluck('id')->toArray())) )checked="checked"  @endif>
                                        &nbsp{{ $team->teamName }} &nbsp &nbsp &nbsp
                                    @endforeach
                                </div>
                            </div>



                            <div class="form-group row">
                                {{--<label for="init-days-off" class="col-md-4 col-form-label text-md-right"></label>--}}
                                <label for="earned-days-off" class="col-xs-12 col-sm-2 col-form-label">{{ __('Number of Earned Days-Off') }}</label>

                                <div class="col-md-6">
                                    <input id="earned-days-off" type="number" class="form-control" name="earnedDaysOff" min="0" max="20"
                                           value="{{ old('earnedDaysOff', $user->earnedDaysOff) }}"  required >
                                           {{--value="$user->earnedDaysOff"  required placeholder="Number of Earned Days-Off">--}}
                                </div>
                            </div>
                            <div class="form-group row mb-0">
                                <div class="col-md-6 offset-md-4">
                                    <button type="submit" class="btn btn-primary" value="send">
                                        {{ __('UPDATE') }}
                                    </button>
                                </div>
                            </div>
                            <input name="_method" value="PUT" type="hidden" >
                            @csrf
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/users/index.blade.php
@extends('layouts.app')
@section('content')
    {{--Search and show results in the same pagebo!--}}
    <div class="container">
        <form action="{{ route('user.index') }}" method="GET" role="search">
            <h5>Search names and emails</h5>
            <div class="input-group">
                <input type="text" class="form-control" name="search" placeholder="Search users" value="{{ $search  }}"><br>
            </div>
            <div>
                <br><h5>Filter by Team membership</h5>
                @foreach($teams as $team)
                    <input type="checkbox" name="teams[]" value="{{ $team->id }}" @if (in_array($team->id, $teamsChecked)) {{ 'checked' }} @endif>
                    {{ $team->teamName }}<br>
                @endforeach

                {{--DATEPICKER jQuery--}}
                <br><h5>Filter by Period - Select a Date Range</h5>
                <label for="from">From</label>
                <input type="text" id="from" name="fromPicked" value="{{ $fromPicked  }}">
                <label for="to">to</label>
                <input type="text" id="to" name="toPicked" value="{{ $toPicked  }}">
            </div>
            <div class="form-group row mb-0">
                <div class="col-md-6 offset-md-4">
                    <button type="submit" value="submit" class="btn btn-primary">
                        {{ __('Search') }}
                    </button>
                </div>
            </div>
            {{--</div>--}}
        </form>
    </div>

    <div class="card-body">
        <h4>Employees List:</h4>
        <div class="col-xs-12 col-sm-2 add_new">
        {{--<div class="col-xs-12 col-sm-4">--}}
            <a href="{{ route('user.create') }}" class="btn btn-secondary">ADD NEW EMPLOYEE</a>
        </div>
        <table class="table">
            <thead>
            <tr>
                <th scope="col">ID</th>
                <th scope="col">Employee</th>
                <th scope="col">Email</th>
                <th scope="col">Teams Membership</th>
                <th scope="col">Approved Holidays (ahead)</th>
                <th scope="col">Edit</th>
                <th scope="col">Delete</th>
            </tr>
            </thead>
    {{--<a href="{{ route('user.show', ['id' => $user->id]) }}">{{ $user->name }}</a>--}}
            <tbody>
            @php($rowOrder = "table-secondary")
            @foreach($users as $user)
                @php($rowOrder = ($rowOrder === "table-secondary") ? 'table-primary' : 'table-secondary')
                <tr class="{{$rowOrder}}">
                    <th scope="row">{{ $user->id }}</th>
                    <td>
                        <a href="{{ route('user.show', ['id' => $user->id]) }}">{{ $user->firstName . ' ' . $user->lastName }}</a>
                    </td>
                    <td>{{ $user->email }}</td>
                    <td>
                        {{--@if($user->teams()->count() > 1)--}}
                        @foreach($user->teams as $team)
                            {{ $team->teamName }}
                            @if (!$loop->last), @endif
                        @endforeach
                        {{--@else--}}
                        {{--Ima manje od dozvoljenog: {{ $user->teams->count() }}--}}
                        {{--@endif--}}
                    </td>
                    <td>
                        @foreach($user->requests as $request)
                            {{--$from = Carbon::createFromFormat('Y-m-d', $request->$from);--}}
                            {{ $request->getDateRange() }}
                            @if (!$loop->last), @endif
                        @endforeach
                    </td>
                    <td>
                        <a href="{{ route('user.edit', ['id' => $user->id]) }}" class="btn btn-primary">EDIT</a>
                    </td>
                    <td>
                    <form   action="{{ route('user.destroy', ['id' => $user->id])  }}" method="post">
                        <div class="col-xs-12 col-sm-4">
                            <button type="submit" value="send" class="btn btn-danger">DELETE</button>
                        </div>
                        @method('DELETE')
                        @csrf
                    </form>
                    </td>
                </tr>
            @endforeach
    </tbody>
</table>
</div>

{{--LARAVEL NEXT I PREVIOWS --}}
{{ $users->render() }}
{{--MANUELNA NEXT I PREVIOWS --}}
{{--@if ($page != 0)
<a href="{{ route('user.index', ['page' => $page - 1]) }}"><button class="btn btn-primary" value="previous">Previous</button></a>
@endif
<a href="{{ route('user.index', ['page' => $page + 1]) }}"><button class="btn btn-primary" value="next">Next</button></a>--}}

@endsection

resources/views/users/show.blade.php
@extends('layouts.app')
@section('content')

<table border="1">
    <tr>
        <th scope="col">ID</th>
        <th scope="col">First Name</th>
        <th scope="col">Last Name</th>
        <th scope="col">Email</th>
        <th scope="col">Gender</th>
        <th scope="col">Total DaysOff</th>
        <th scope="col">Teams Membership</th>
        <th scope="col">Role</th>
    </tr>
    <tr class="table-primary">
        <td>{{ $user->id }}</td>
        <td>{{ $user->firstName }}</td>
        <td>{{ $user->lastName }}</td>
        <td>{{ $user->email }}</td>
        <td>{{ $user->gender }}</td>
        <td>{{ $user->earnedDaysOff }}</td>
        <td>
            @foreach($user->teams as $team)
                {{ $team->teamName }}
                @if (!$loop->last), @endif
            @endforeach
        </td>
        <td>{{ $user->role }}</td>
    </tr>
</table>
</br>
<div class="col-xs-12 col-sm-2 add_new">
<a href="{{ url('/user') }}" class="btn btn-secondary home">Employee List</a>
</div>
@endsection